Unit MNKO3_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MNKO3(A :Real; B :Real; C :Real; E :Real; F :Real; G :Real;
                var HT :Real; EM :Integer);

implementation

procedure MNKO3(A :Real; B :Real; C :Real; E :Real; F :Real; G :Real;
                var HT :Real; EM :Integer);
var
L,M,O,Q,R,S,T,U,V :Real;
label
_1;
begin
{   OCTPOEHE APAO O TOKAM A,B,C }
{    OPEEEHE TOK EE MHMYMA HT }
L := (B-A)/(C-A);
if ( L < Power(10.,-EM +3) ) 
 then goto _1;
if ( 1-L < Power(10.,-EM +3) ) 
 then goto _1;
M := E/G;
O := (F/G-M)/L;
Q := (1-M-O)/(1-L);
R := O-Q*L;
if ( Abs(R) < Power(10.,-EM +4) ) 
 then goto _1;
if ( Abs(Q) < Power(10.,-EM +2) ) 
 then goto _1;
if ( R*R-4*Q*M < 0 ) 
 then goto _1;
S := Sqrt(R*R-4*Q*M)/Abs(R);
T := -R/(2*Q);
U := T*(1-S);
V := T*(1+S);
if ( (U >= 0.0) ) and ( (U <= 1.0) ) 
 then HT := U;
if ( (V >= 0.0) ) and ( (V <= 1.0) ) 
 then HT := V;
HT := HT*(C-A)+A;
_1:
end;

end.
